/*
ADXL345бģ
*/
#include "ADXL345.h"
#include "IIC.h"

/**
  * @brief  ADXL345ʼ
  * @param  None
  * @retval None
  */
uint8_t ADXL345_init(void)
{
	IIC_init();
	if(ADXL345_read_reg(DEVICE_ID) == 0xE5)
	{
		ADXL345_write_reg(DATA_FORMAT,0X0B); // ͵ƽж,13λȫֱ,Ҷ,16g 
		ADXL345_write_reg(BW_RATE,0x0E); // ٶΪ100Hz
		ADXL345_write_reg(POWER_CTL,0x08); // ʹ,ģʽ,ʡ
		ADXL345_write_reg(INT_ENABLE,0x80); // ʹж		 
	 	ADXL345_write_reg(OFSX,0x00);
		ADXL345_write_reg(OFSY,0x00);
		ADXL345_write_reg(OFSZ,0x05);
		return 0;
	}
	return 1;
}
/**
  * @brief  ADXL345дĴ
  * @param  None
  * @retval None
  */
uint8_t ADXL345_write_reg(u8 addr,u8 val) 
{
	IIC_start();  				 
	IIC_send_byte(slaveaddress); // дָ	 
	if(IIC_wait_ack())
	{
		return 1;
	}    
  IIC_send_byte(addr); // ͼĴַ
	if(IIC_wait_ack())
	{
		return 2;
	} 	 										  		   
	IIC_send_byte(val); // ֵ					   
	if(IIC_wait_ack())
	{
		return 3;
	}   		    	   
  IIC_stop(); // һֹͣ 	   
	return 0;
}
/**
  * @brief  ADXL345Ĵ
  * @param  None
  * @retval None
  */
u8 ADXL345_read_reg(u8 addr)
{
	u8 temp=0;		 
	IIC_start();  				 
	IIC_send_byte(slaveaddress); // дָ	 
	if(IIC_wait_ack())
	{
		return 1;
	}   
  IIC_send_byte(addr); // ͼĴַ
	if(IIC_wait_ack())
	{
		return 2;
	}  										  		   
	IIC_start(); // 
	IIC_send_byte(regaddress); // Ͷָ	 
	if(IIC_wait_ack())
	{
		return 3;
	} 	   
  temp=IIC_read_byte(0); // ȡһֽ,ٶ,NAK
  IIC_stop(); // һֹͣ 	    
	return temp;
}
/**
  * @brief  ADXL345ȡ
  * @param  None
  * @retval None
  */
void ADXL345_read_data(short *x,short *y,short *z)
{
	u8 buf[6];
	u8 i;
	IIC_start();  				 
	IIC_send_byte(slaveaddress); // дָ	 
	IIC_wait_ack();	   
  IIC_send_byte(0x32); // ͼĴַ(ݻʼַΪ0X32)
	IIC_wait_ack(); 	 										  		   
 
 	IIC_start(); // 
	IIC_send_byte(regaddress); // Ͷָ
	IIC_wait_ack();
	for(i=0;i<6;i++)
	{
		if(i==5)buf[i]=IIC_read_byte(0); // ȡһֽ,ٶ,NACK  
		else buf[i]=IIC_read_byte(1);	// ȡһֽ,,ACK 
 	}	        	   
  IIC_stop();	// һֹͣ
	*x=(short)(((u16)buf[1]<<8)+buf[0]); // ϳ    
	*y=(short)(((u16)buf[3]<<8)+buf[2]); 	    
	*z=(short)(((u16)buf[5]<<8)+buf[4]); 
}
/**
  * @brief  ADXL345ȡȡƽֵ
  * @param  None
  * @retval None
  */
void ADXL345_read_average(short *x,short *y,short *z,u8 times)
{
	u8 i;
	short tx,ty,tz;
	*x=0;
	*y=0;
	*z=0;
	if(times)//ȡΪ0
	{
		for(i=0;i<times;i++)//ȡtimes
		{
			ADXL345_read_data(&tx,&ty,&tz);
			*x+=tx;
			*y+=ty;
			*z+=tz;
			DELAYClass.DelayMs(5);
		}
		*x/=times;
		*y/=times;
		*z/=times;
	}
}
/**
  * @brief  ADXL345Ƕ
  * @param  None
  * @retval None
  */
void get_angle(float *x_angle,float *y_angle,float *z_angle)
{
	short ax,ay,az;
	ADXL345_read_average(&ax,&ay,&az,10);
	*x_angle=atan(ax/sqrt((az*az+ay*ay)))*180/3.14;
	*y_angle=atan(ay/sqrt((ax*ax+az*az)))*180/3.14;
	*z_angle=atan(sqrt((ax*ax+ay*ay)/az))*180/3.14;
}
