#include "ds1302.h"

static void DS1302_WriteByte(uint8_t addr,uint8_t data);
static uint8_t DS1302_ReadByte(uint8_t addr);

static void DS1302_Init(void);
static void DS1302_SetTime(uint8_t *writeTime);
static void DS1302_GetTime(DS1302TimeStruct *timeData);

DS1302ClassStruct DS1302Class = {
	.Init = DS1302_Init,
	.SetTime = DS1302_SetTime,
	.GetTime = DS1302_GetTime
};

/*
ʼʱ䶨{0x20,0x21,0x11,0x13,0x10,0x10,0x00,0x06};
ʼʱ20211113101000 
*/
uint8_t time_buf[8] = {0x20};//ʼʱ
uint8_t readtime[8] = {0x20};//ǰʱ

//DS1302Ŷ,ɸʵ޸Ķ˿ڶ
#define DS1302_CLK_PORT					GPIOA
#define DS1302_CLK_CLK					RCC_APB2Periph_GPIOA
#define DS1302_CLK_PIN					GPIO_Pin_4

#define DS1302_DAT_PORT					GPIOA
#define DS1302_DAT_CLK					RCC_APB2Periph_GPIOA
#define DS1302_DAT_PIN					GPIO_Pin_5

#define DS1302_RST_PORT					GPIOA
#define DS1302_RST_CLK					RCC_APB2Periph_GPIOA
#define DS1302_RST_PIN					GPIO_Pin_6

// Pin0-7CRLĴ Pin8-15CRHĴ ģʽ
#define DS1302_DAT_OutPut_Mode()	{DS1302_DAT_PORT->CRL &= 0xFF0FFFFF;DS1302_DAT_PORT->CRL |= 0x00300000;}
#define DS1302_DAT_InPut_Mode()		{DS1302_DAT_PORT->CRL &= 0xFF0FFFFF;DS1302_DAT_PORT->CRL |= 0x00400000;}

//DS1302
#define DS1302_DAT_IN()  		GPIO_ReadInputDataBit(DS1302_DAT_PORT, DS1302_DAT_PIN)
#define DS1302_CLK_0 				DS1302_CLK_PORT->BSRR = (uint32_t)DS1302_CLK_PIN<<16 // 0
#define DS1302_CLK_1      	DS1302_CLK_PORT->BSRR = (uint32_t)DS1302_CLK_PIN // 1
#define DS1302_DAT_0 				DS1302_DAT_PORT->BSRR = (uint32_t)DS1302_DAT_PIN<<16 // 0
#define DS1302_DAT_1				DS1302_DAT_PORT->BSRR = (uint32_t)DS1302_DAT_PIN // 1
#define DS1302_RST_0 				DS1302_RST_PORT->BSRR = (uint32_t)DS1302_RST_PIN<<16 // 0
#define DS1302_RST_1 				DS1302_RST_PORT->BSRR = (uint32_t)DS1302_RST_PIN // 1

//DS1302ַ
#define DS1302_SEC_ADDR           0x80		//ݵַ
#define DS1302_MIN_ADDR           0x82		//ݵַ
#define DS1302_HOUR_ADDR          0x84		//ʱݵַ
#define DS1302_DAY_ADDR           0x86		//ݵַ
#define DS1302_MONTH_ADDR         0x88		//ݵַ
#define DS1302_WEEK_ADDR          0x8a		//ݵַ
#define DS1302_YEAR_ADDR          0x8c		//ݵַ
#define DS1302_CONTROL_ADDR       0x8e		//ݵַ
#define DS1302_CHARGER_ADDR       0x90 		//繦ַܵ			 
#define DS1302_CLKBURST_ADDR      0xbe

//DS1302дһֽ
static void DS1302_WriteByte(uint8_t addr,uint8_t data) 
{
	uint8_t i;
	DS1302_RST_0; //ֹݴ Ҫ
	DS1302_CLK_0; //ȷдǰSCLKΪ͵ƽ
	DS1302_RST_1;	//DS1302	
	DS1302_DAT_OutPut_Mode();
	addr=addr&0xFE;  //λ㣬Ĵ0λΪ0ʱдΪ1ʱ
	for(i=0;i<8;i++) //дĿַaddr
	{
		if (addr&0x01) DS1302_DAT_1;
		else DS1302_DAT_0;
		DS1302_CLK_1; //ʱд
		DS1302_CLK_0;
		addr=addr>>1;
	}	
	for (i=0;i<8;i++) //дݣdata
	{
		if(data&0x01) DS1302_DAT_1;
		else DS1302_DAT_0;
		DS1302_CLK_1;    //ʱд
		DS1302_CLK_0;
		data = data >> 1;
	}
	DS1302_CLK_1;    // ʱӵƽڸߵƽ״̬ ֪״̬
	DS1302_RST_0;	//ֹͣDS1302
}
 
//DS1302һֽ
static uint8_t DS1302_ReadByte(uint8_t addr) 
{
	uint8_t i,temp;	
	DS1302_RST_0; //Ҫ
	DS1302_CLK_0; //ȽSCLKõ͵ƽ,ȷдǰSCLK
	DS1302_RST_1; //DS1302
	DS1302_DAT_OutPut_Mode();
	//дĿַaddr
	addr=addr|0x01; //λøߣĴ0λΪ0ʱдΪ1ʱ
	for(i=0;i<8;i++) 
	{
		if (addr&0x01) DS1302_DAT_1;
		else DS1302_DAT_0;
		DS1302_CLK_1; //д
		DS1302_CLK_0;
		addr = addr >> 1;
	}	
	//DS1302ݣtemp
	DS1302_DAT_InPut_Mode();
	for(i=0;i<8;i++)
	{
		temp=temp>>1;
		if (DS1302_DAT_IN()) temp|=0x80;
		else temp&=0x7F;
		DS1302_CLK_1;
		DS1302_CLK_0;
	}	
	DS1302_CLK_1;  //ʱӵƽ֪״̬
	DS1302_RST_0;	//ֹͣDS1302
	return temp;
}
/**
  * @brief  DS1302ųʼ
  * @param  None
  * @retval None
  * @note   None
  */
static void DS1302_Init(void) 
{
	GPIO_InitTypeDef GPIO_InitStructure;
	RCC_APB2PeriphClockCmd(DS1302_CLK_CLK | DS1302_DAT_CLK | DS1302_RST_CLK, ENABLE);
	
	GPIO_InitStructure.GPIO_Pin=DS1302_CLK_PIN;
	GPIO_InitStructure.GPIO_Mode=GPIO_Mode_Out_PP;
	GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;
	GPIO_Init(DS1302_CLK_PORT,&GPIO_InitStructure);
	GPIO_InitStructure.GPIO_Pin=DS1302_RST_PIN;
	GPIO_Init(DS1302_RST_PORT,&GPIO_InitStructure);
	GPIO_InitStructure.GPIO_Pin=DS1302_DAT_PIN;
	GPIO_Init(DS1302_DAT_PORT,&GPIO_InitStructure);
}
/**
  * @brief  дDS1302ʱݣʼʱֵ
  * @param  None
  * @retval None
  * @note   None
  */
static void DS1302_SetTime(uint8_t *writeTime) 
{
	DS1302_WriteByte(DS1302_CONTROL_ADDR,0x00);       //رд
	DS1302_WriteByte(DS1302_SEC_ADDR,0x80);           //ͣʱ 
	//DS1302_WriteByte(DS1302_CHARGER_ADDR,0xa9);     // 
	DS1302_WriteByte(DS1302_YEAR_ADDR,writeTime[1]);   // 
	DS1302_WriteByte(DS1302_MONTH_ADDR,writeTime[2]);  // 
	DS1302_WriteByte(DS1302_DAY_ADDR,writeTime[3]);    // 
	DS1302_WriteByte(DS1302_HOUR_ADDR,writeTime[4]);   //ʱ 
	DS1302_WriteByte(DS1302_MIN_ADDR,writeTime[5]);    //
	DS1302_WriteByte(DS1302_SEC_ADDR,writeTime[6]);    //
	DS1302_WriteByte(DS1302_WEEK_ADDR,writeTime[7]);	  // 
	DS1302_WriteByte(DS1302_CHARGER_ADDR,0xA5);//򿪳繦 ѡ2K緽ʽ
	DS1302_WriteByte(DS1302_CONTROL_ADDR,0x80);//д 
}
/**
  * @brief  ȡDS1302ʱ
  * @param  None
  * @retval None
  * @note   None
  */
static void DS1302_GetTime(DS1302TimeStruct *timeData)
{ 
	uint8_t readtime[8] = {0x20};//ǰʱ
  readtime[1]=DS1302_ReadByte(DS1302_YEAR_ADDR);          // 
	readtime[2]=DS1302_ReadByte(DS1302_MONTH_ADDR);         // 
	readtime[3]=DS1302_ReadByte(DS1302_DAY_ADDR);           // 
	readtime[4]=DS1302_ReadByte(DS1302_HOUR_ADDR);          //ʱ 
	readtime[5]=DS1302_ReadByte(DS1302_MIN_ADDR);           // 
	readtime[6]=(DS1302_ReadByte(DS1302_SEC_ADDR))&0x7f;    //룬ĵ7λⳬ59
	readtime[7]=DS1302_ReadByte(DS1302_WEEK_ADDR);          // 	
	timeData->year=(readtime[0]>>4)*1000+(readtime[0]&0x0F)*100+(readtime[1]>>4)*10+(readtime[1]&0x0F); //
	timeData->month=(readtime[2]>>4)*10+(readtime[2]&0x0F);  //·
	timeData->day=(readtime[3]>>4)*10+(readtime[3]&0x0F);    //
	timeData->hour=(readtime[4]>>4)*10+(readtime[4]&0x0F);   //Сʱ
	timeData->minute=(readtime[5]>>4)*10+(readtime[5]&0x0F); //
	timeData->second=(readtime[6]>>4)*10+(readtime[6]&0x0F); //
	timeData->week=(readtime[7]&0x0F);                       //		
#ifdef DEBUG_printf
	//printf("read: %d%d%d %dʱ%d%d\n", timeData->year, timeData->month, timeData->day, timeData->hour, timeData->minute, timeData->second);	
#endif
}

