/* include ---------------------------------------------------------*/
#include <main.h>



/* private define -------------------------------------------------*/
// SCK=Tx DT=Rx
#define HX711_SCK_GPIO_PORT    			GPIOA			              /* GPIO˿ */
#define HX711_SCK_GPIO_CLK 	    		RCC_APB2Periph_GPIOA		/* GPIO˿ʱ */
#define HX711_SCK_GPIO_PIN				GPIO_Pin_4			        /* ӵSCLʱߵGPIO */

#define HX711_DT_GPIO_PORT    			GPIOA			              /* GPIO˿ */
#define HX711_DT_GPIO_CLK 	    		RCC_APB2Periph_GPIOA		/* GPIO˿ʱ */
#define HX711_DT_GPIO_PIN				GPIO_Pin_5			        /* ӵSCLʱߵGPIO */

/* private variables ----------------------------------------------*/
 uint32_t HX711_Buffer = 0;

/* private function prototypes ------------------------------------*/
static void Init(void);
static uint32_t Read(void);
static uint32_t GetValue(void);

/* public variables -----------------------------------------------*/
HX711_t HX711 =
{
    Init,
    GetValue
};

/**
  * @brief  ʼ
  * @param  None
  * @retval None
  * @note   None
*/
static void Init(void)
{
    GPIO_InitTypeDef GPIO_InitStructure;
	
	RCC_APB2PeriphClockCmd(HX711_SCK_GPIO_CLK | HX711_DT_GPIO_CLK, ENABLE);
	
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
	GPIO_InitStructure.GPIO_Pin = HX711_DT_GPIO_PIN;
	GPIO_Init(HX711_DT_GPIO_PORT, &GPIO_InitStructure);
	
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
	GPIO_InitStructure.GPIO_Pin = HX711_SCK_GPIO_PIN;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(HX711_SCK_GPIO_PORT, &GPIO_InitStructure);
	
	DELAYClass.DelayMs(500);
	
	HX711_Buffer = Read();
	
	DELAYClass.DelayMs(500);
	
	HX711_Buffer = Read();
}

/**
  * @brief  ȡ
  * @param  None
  * @retval None
  * @note   None
*/
static uint32_t Read(void)
{
	uint8_t i;
	uint32_t value = 0;
	uint16_t cnt = 65535;
	
	/**
	ֲдܽ DOUT ΪߵƽʱA/D תδ׼ݣʱʱ
	ź PD_SCK ӦΪ͵ƽ״̬
	**/
	GPIO_SetBits(HX711_DT_GPIO_PORT, HX711_DT_GPIO_PIN); //ʼ״̬DTΪߵƽ
	GPIO_ResetBits(HX711_SCK_GPIO_PORT, HX711_SCK_GPIO_PIN); //ʼ״̬SCKΪ͵ƽ
	
	/**
	ȴDTűΪߵƽ
	**/
	while(GPIO_ReadInputDataBit(HX711_DT_GPIO_PORT, HX711_DT_GPIO_PIN)) {
		cnt--;
		if(!cnt) break;
	}
	DELAYClass.DelayUs(1);
	
	/**
	 DOUT Ӹߵƽ͵ƽPD_SCK Ӧ 25  27 ȵʱ
	25ʱ ---> ͨA 128
	26ʱ ---> ͨB 32
	27ʱ ---> ͨA 64
	**/
	for(i=0; i<24; i++) //24λݴλλλ
	{
		//
		GPIO_SetBits(HX711_SCK_GPIO_PORT, HX711_SCK_GPIO_PIN);
		DELAYClass.DelayUs(1);
		GPIO_ResetBits(HX711_SCK_GPIO_PORT, HX711_SCK_GPIO_PIN);
		if(GPIO_ReadInputDataBit(HX711_DT_GPIO_PORT, HX711_DT_GPIO_PIN) == 0)
		{
			value = value << 1;
			value |= 0x00;
		}
		if(GPIO_ReadInputDataBit(HX711_DT_GPIO_PORT, HX711_DT_GPIO_PIN) == 1)
		{
			value = value << 1;
			value |= 0x01;
		}
		DELAYClass.DelayUs(1);
	}
	
	// 25 27 ʱѡһ A/D תͨ
	GPIO_SetBits(HX711_SCK_GPIO_PORT, HX711_SCK_GPIO_PIN); 
	value = value^0x800000; 
	DELAYClass.DelayUs(1); 
	GPIO_ResetBits(HX711_SCK_GPIO_PORT, HX711_SCK_GPIO_PIN); 
	DELAYClass.DelayUs(1);  
	return value;
}


/**
  * @brief  ȡ
  * @param  None
  * @retval None
  * @note   None
*/
static uint32_t GetValue(void)
{
	uint32_t value_t = Read();
	uint32_t Weight_Shiwu = 0;

	if ( value_t > HX711_Buffer )
	{
		Weight_Shiwu	= value_t;
		Weight_Shiwu	= Weight_Shiwu - HX711_Buffer;                          /* ȡʵADֵ */

		Weight_Shiwu = (unsigned long) ( (float) Weight_Shiwu / 0.38755);      /* ʵʵ */


		/*
		 * ΪͬĴ߲һˣÿһҪGapValue
		 * ֲԳƫʱӸֵ
		 * ԳƫСʱСֵ
		 * ֵһ4.0-5.0֮䡣򴫸ͬ
		 * +0.05Ϊٷλ
		 */
	}
	
	return Weight_Shiwu/1000;
	
}

