#include "IIC.h"


#define GPIO_PORT_I2C	GPIOB					/* GPIO˿ */
#define RCC_I2C_PORT 	RCC_APB2Periph_GPIOB	/* GPIO˿ʱ */
#define I2C_SCL_PIN		GPIO_Pin_1				/* ӵSCLʱߵGPIO */
#define I2C_SDA_PIN		GPIO_Pin_0				/* ӵSDAߵGPIO */

/* дSCLSDAĺ꣬ӴĿֲԺͿĶ */
#if 0	/* 룺 1 ѡGPIOĿ⺯ʵIOд */
	#define I2C_SCL_1()  GPIO_SetBits(GPIO_PORT_I2C, I2C_SCL_PIN)		/* SCL = 1 */
	#define I2C_SCL_0()  GPIO_ResetBits(GPIO_PORT_I2C, I2C_SCL_PIN)		/* SCL = 0 */
	
	#define I2C_SDA_1()  GPIO_SetBits(GPIO_PORT_I2C, I2C_SDA_PIN)		/* SDA = 1 */
	#define I2C_SDA_0()  GPIO_ResetBits(GPIO_PORT_I2C, I2C_SDA_PIN)		/* SDA = 0 */
	
	#define I2C_SDA_READ()  GPIO_ReadInputDataBit(GPIO_PORT_I2C, I2C_SDA_PIN)	/* SDA״̬ */
#else	/* ֧ѡֱӼĴʵIOд */
    /*ע⣺дIAR߼ŻʱᱻŻ */
	#define I2C_SCL_1()  GPIO_PORT_I2C->BSRR = I2C_SCL_PIN				/* SCL = 1 */
	#define I2C_SCL_0()  GPIO_PORT_I2C->BRR = I2C_SCL_PIN				/* SCL = 0 */
	
	#define I2C_SDA_1()  GPIO_PORT_I2C->BSRR = I2C_SDA_PIN				/* SDA = 1 */
	#define I2C_SDA_0()  GPIO_PORT_I2C->BRR = I2C_SDA_PIN				/* SDA = 0 */
	
	#define I2C_SDA_READ()  ((GPIO_PORT_I2C->IDR & I2C_SDA_PIN) != 0)	/* SDA״̬ */
#endif

/*
*********************************************************************************************************
*	  : IIC_delay
*	˵: I2Cλӳ٣400KHz
*	    Σ
*	  ֵ: 
*********************************************************************************************************
*/
static void IIC_delay(void)
{
	uint8_t i;

	/*
	 	ʱͨAX-Pro߼ǲԵõġ
		CPUƵ72MHzʱڲFlash, MDK̲Ż
		ѭΪ10ʱSCLƵ = 205KHz 
		ѭΪ7ʱSCLƵ = 347KHz SCLߵƽʱ1.5usSCL͵ƽʱ2.87us 
	 	ѭΪ5ʱSCLƵ = 421KHz SCLߵƽʱ1.25usSCL͵ƽʱ2.375us 
        
    IAṞЧʸߣΪ7
	*/
	for (i = 0; i < 10; i++);
}

/*
*********************************************************************************************************
*	  : IIC_start
*	˵: CPUI2Cź
*	    Σ
*	  ֵ: 
*********************************************************************************************************
*/
void IIC_start(void)
{
	/* SCLߵƽʱSDAһرʾI2Cź */
	I2C_SDA_1();
	I2C_SCL_1();
	IIC_delay();
	I2C_SDA_0();
	IIC_delay();
	I2C_SCL_0();
	IIC_delay();
}

/*
*********************************************************************************************************
*	  : IIC_start
*	˵: CPUI2Cֹͣź
*	    Σ
*	  ֵ: 
*********************************************************************************************************
*/
void IIC_stop(void)
{
	/* SCLߵƽʱSDAһرʾI2Cֹͣź */
	I2C_SDA_0();
	I2C_SCL_1();
	IIC_delay();
	I2C_SDA_1();
}

/*
*********************************************************************************************************
*	  : IIC_send_byte
*	˵: CPUI2C豸8bit
*	    Σ_ucByte  ȴ͵ֽ
*	  ֵ: 
*********************************************************************************************************
*/
void IIC_send_byte(uint8_t _ucByte)
{
	uint8_t i;

	/* ȷֽڵĸλbit7 */
	for (i = 0; i < 8; i++)
	{		
		if (_ucByte & 0x80)
		{
			I2C_SDA_1();
		}
		else
		{
			I2C_SDA_0();
		}
		IIC_delay();
		I2C_SCL_1();
		IIC_delay();	
		I2C_SCL_0();
		if (i == 7)
		{
			 I2C_SDA_1(); // ͷ
		}
		_ucByte <<= 1;	/* һbit */
		IIC_delay();
	}
}

/*
*********************************************************************************************************
*	  : IIC_read_byte
*	˵: CPUI2C豸ȡ8bit
*	    Σ
*	  ֵ: 
*********************************************************************************************************
*/
uint8_t IIC_read_byte(u8 ack)
{
	uint8_t i;
	uint8_t value;

	/* 1bitΪݵbit7 */
	value = 0;
	for (i = 0; i < 8; i++)
	{
		value <<= 1;
		I2C_SCL_1();
		IIC_delay();
		if (I2C_SDA_READ())
		{
			value++;
		}
		I2C_SCL_0();
		IIC_delay();
	}
	if(ack==0)
		IIC_nack();
	else
		IIC_ack();
	return value;
}

/*
*********************************************************************************************************
*	  : IIC_wait_ack
*	˵: CPUһʱӣȡACKӦź
*	    Σ
*	  ֵ: 0ʾȷӦ1ʾӦ
*********************************************************************************************************
*/
uint8_t IIC_wait_ack(void)
{
	uint8_t re;

	I2C_SDA_1();	/* CPUͷSDA */
	IIC_delay();
	I2C_SCL_1();	/* CPUSCL = 1, ʱ᷵ACKӦ */
	IIC_delay();
	if (I2C_SDA_READ())	/* CPUȡSDA״̬ */
	{
		re = 1;
	}
	else
	{
		re = 0;
	}
	I2C_SCL_0();
	IIC_delay();
	return re;
}

/*
*********************************************************************************************************
*	  : IIC_ack
*	˵: CPUһACKź
*	    Σ
*	  ֵ: 
*********************************************************************************************************
*/
void IIC_ack(void)
{
	I2C_SDA_0();	/* CPUSDA = 0 */
	IIC_delay();
	I2C_SCL_1();	/* CPU1ʱ */
	IIC_delay();
	I2C_SCL_0();
	IIC_delay();
	I2C_SDA_1();	/* CPUͷSDA */
}

/*
*********************************************************************************************************
*	  : IIC_nack
*	˵: CPU1NACKź
*	    Σ
*	  ֵ: 
*********************************************************************************************************
*/
void IIC_nack(void)
{
	I2C_SDA_1();	/* CPUSDA = 1 */
	IIC_delay();
	I2C_SCL_1();	/* CPU1ʱ */
	IIC_delay();
	I2C_SCL_0();
	IIC_delay();	
}

/*
*********************************************************************************************************
*	  : i2c_GPIO_Config
*	˵: I2CߵGPIOģIOķʽʵ
*	    Σ
*	  ֵ: 
*********************************************************************************************************
*/
void IIC_init(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;

	RCC_APB2PeriphClockCmd(RCC_I2C_PORT, ENABLE);	/* GPIOʱ */

	GPIO_InitStructure.GPIO_Pin = I2C_SCL_PIN | I2C_SDA_PIN;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_OD;  	/* © */
	GPIO_Init(GPIO_PORT_I2C, &GPIO_InitStructure);

	/* һֹͣź, λI2Cϵ豸ģʽ */
	IIC_stop();
}
