#include "MPU6050.h"
#include "IIC.h"


/**
  * @brief   дݵMPU6050Ĵ
  * @param   
  * @retval  
  */
void MPU6050_WriteReg(u8 reg_add,u8 reg_dat)
{
	IIC_start();
	IIC_send_byte(MPU6050_WriteAddr);
	IIC_wait_ack();
	IIC_send_byte(reg_add);
	IIC_wait_ack();
	IIC_send_byte(reg_dat);
	IIC_wait_ack();
	IIC_stop();
}
/**
  * @brief   MPU6050Ĵȡ
  * @param   
  * @retval  
  */
void MPU6050_ReadData(u8 reg_add,unsigned char*Read,u8 num)
{
	unsigned char i;
	
	IIC_start();
	IIC_send_byte(MPU6050_WriteAddr);
	IIC_wait_ack();
	IIC_send_byte(reg_add);
	IIC_wait_ack();
	
	IIC_start();
	IIC_send_byte(MPU6050_ReadAddr);
	IIC_wait_ack();
	
	for(i=0;i<(num-1);i++){
		*Read=IIC_read_byte(1);
		Read++;
	}
	*Read=IIC_read_byte(0);
	IIC_stop();
}


/**
  * @brief   ʼMPU6050оƬ
  * @param   
  * @retval  
  */
void MPU6050_Init(void)
{
	IIC_init();
	//ڳʼ֮ǰҪʱһʱ䣬ûʱϵϵݿܻ
	DELAYClass.DelayMs(1000);
	MPU6050_WriteReg(MPU6050_RA_PWR_MGMT_1, 0x00);	    //״̬
	MPU6050_WriteReg(MPU6050_RA_SMPLRT_DIV , 0x07);	    //ǲʣ1KHz
	MPU6050_WriteReg(MPU6050_RA_CONFIG , 0x06);	        //ͨ˲ãֹƵ1K5K
	MPU6050_WriteReg(MPU6050_RA_ACCEL_CONFIG , 0x00);	  //üٶȴ2GģʽԼ
	MPU6050_WriteReg(MPU6050_RA_GYRO_CONFIG, 0x18);     //Լ켰Χֵ0x18(Լ죬2000deg/s)
	MPU6050ReadID();
}

/**
  * @brief   ȡMPU6050ID
  * @param   
  * @retval  
  */
uint8_t MPU6050ReadID(void)
{
	unsigned char Re = 0;
    MPU6050_ReadData(MPU6050_RA_WHO_AM_I,&Re,1);    //ַ
	if(Re != 0x68)
	{
		printf("MPU6050 dectected error!\n");
		return 0;
	}
	else
	{
		printf("MPU6050 ID = 0x%02X\n",Re);
		return 1;
	}
		
}
/**
  * @brief   ȡMPU6050ļٶ
  * @param   
  * @retval  
  */
void MPU6050ReadAcc(short *accData)
{
    u8 buf[6];
    MPU6050_ReadData(MPU6050_ACC_OUT, buf, 6);
    accData[0] = (buf[0] << 8) | buf[1];
    accData[1] = (buf[2] << 8) | buf[3];
    accData[2] = (buf[4] << 8) | buf[5];
}

/**
  * @brief   ȡMPU6050ĽǼٶ
  * @param   
  * @retval  
  */
void MPU6050ReadGyro(short *gyroData)
{
    u8 buf[6];
    MPU6050_ReadData(MPU6050_GYRO_OUT,buf,6);
    gyroData[0] = (buf[0] << 8) | buf[1];
    gyroData[1] = (buf[2] << 8) | buf[3];
    gyroData[2] = (buf[4] << 8) | buf[5];
}


/**
  * @brief   ȡMPU6050ԭʼ¶
  * @param   
  * @retval  
  */
void MPU6050ReadTemp(short *tempData)
{
	u8 buf[2];
    MPU6050_ReadData(MPU6050_RA_TEMP_OUT_H,buf,2);     //ȡ¶ֵ
    *tempData = (buf[0] << 8) | buf[1];
}


/**
  * @brief   ȡMPU6050¶ݣת϶
  * @param   
  * @retval  
  */
void MPU6050_ReturnTemp(float *Temperature)
{
	short temp3;
	u8 buf[2];
	
	MPU6050_ReadData(MPU6050_RA_TEMP_OUT_H,buf,2);     //ȡ¶ֵ
  temp3= (buf[0] << 8) | buf[1];	
	*Temperature=((double) temp3/340.0)+36.53;

}
