#include "main.h"
//#include "stm32f10x.h"
//#include "ESP8266.h"
//#include "delay.h"
//#include "usart.h"
//#include <string.h>
//#include <stdio.h>

#define ESP8266_GPIO_PORT    	GPIOA			              /* GPIO˿ */
#define ESP8266_GPIO_CLK 	    RCC_APB2Periph_GPIOA		/* GPIO˿ʱ */
#define ESP8266_GPIO_PIN			GPIO_Pin_1			        /* ӵSCLʱߵGPIO */
#define ESP8266_UART					USART2									/* ں */
// WIFIϢ
#define ESP8266_WIFI_INFO			"AT+CWJAP=\"MNIAS\",\"0123456789\"\r\n"
// TCPϢ Ĭϲ
#define ESP8266_ONENET_INFO		"AT+CIPSTART=\"TCP\",\"183.230.40.39\",6002\r\n"

unsigned char ESP8266_buf[128];
unsigned short ESP8266_cnt = 0, ESP8266_cntPre = 0;


/**
  * @brief  OneNETʹôڵĴжϺ
  * @param  None
  * @retval None
  */
void USART2_IRQHandler(void)
{
	if(USART_GetITStatus(ESP8266_UART, USART_IT_RXNE) != RESET)
	{
		
		if(ESP8266_cnt >= sizeof(ESP8266_buf))	ESP8266_cnt = 0; //ֹڱˢ
		ESP8266_buf[ESP8266_cnt++] = ESP8266_UART->DR;
		
		USART_ClearFlag(ESP8266_UART, USART_FLAG_RXNE);
	}
}
/**
  * @brief  ESP8266ʼ
  * @param  None
  * @retval None
  */
void ESP8266_Init(void)
{
	GPIO_InitTypeDef GPIO_Initure;
	RCC_APB2PeriphClockCmd(ESP8266_GPIO_CLK, ENABLE);
	// ESP8266λ
	GPIO_Initure.GPIO_Mode = GPIO_Mode_Out_PP;
	GPIO_Initure.GPIO_Pin = ESP8266_GPIO_PIN;					
	GPIO_Initure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(ESP8266_GPIO_PORT, &GPIO_Initure);
	
	GPIO_WriteBit(ESP8266_GPIO_PORT, ESP8266_GPIO_PIN, Bit_RESET);
	DELAYClass.DelayMs(250);
	GPIO_WriteBit(ESP8266_GPIO_PORT, ESP8266_GPIO_PIN, Bit_SET);
	DELAYClass.DelayMs(500);
	
	ESP8266_Clear();
#ifdef DEBUG_printf
	printf("1. AT\r\n");
#endif
	while(ESP8266_SendCmd("AT\r\n", "OK")) DELAYClass.DelayMs(500);
#ifdef DEBUG_printf
	printf("2. CWMODE\r\n");
#endif
	while(ESP8266_SendCmd("AT+CWMODE=1\r\n", "OK")) DELAYClass.DelayMs(500);
//	printf( "3.AT+CWSTARTSMART=3\r\n");//֧ESP-TouchAirkiss
//	while(ESP8266_SendCmd("AT+CWSTARTSMART=3\r\n", "GOT IP")) DELAYClass.DelayMs(500);
#ifdef DEBUG_printf
	printf("4. AT+CWDHCP\r\n");
#endif
	while(ESP8266_SendCmd("AT+CWDHCP=1,1\r\n", "OK")) DELAYClass.DelayMs(500);
#ifdef DEBUG_printf
	printf("5. CWJAP\r\n");
#endif
	while(ESP8266_SendCmd(ESP8266_WIFI_INFO, "GOT IP")) DELAYClass.DelayMs(500);
#ifdef DEBUG_printf	
	printf("6. CIPSTART\r\n");
#endif
	while(ESP8266_SendCmd(ESP8266_ONENET_INFO, "CONNECT")) DELAYClass.DelayMs(500);
#ifdef DEBUG_printf
	printf("7. ESP8266 Init OK\r\n");
#endif
}
/**
  * @brief  WIFIڻ
  * @param  None
  * @retval None
  */
void ESP8266_Clear(void)
{
	memset(ESP8266_buf, 0, sizeof(ESP8266_buf));
	ESP8266_cnt = 0;
}
/**
  * @brief  ȴ
  * @param  None
  * @retval REV_OK-		REV_WAIT-ճʱδ
	* @note   ѭüǷ
  */
_Bool ESP8266_WaitRecive(void)
{

	if(ESP8266_cnt == 0) 							//ռΪ0 ˵ûдڽУֱ
		return REV_WAIT;

	if(ESP8266_cnt == ESP8266_cntPre)				//һεֵͬ˵
	{
		ESP8266_cnt = 0;							//0ռ
			
		return REV_OK;								//ؽɱ־
	}

	ESP8266_cntPre = ESP8266_cnt;					//Ϊͬ
	
	return REV_WAIT;								//ؽδɱ־

}
/**
  * @brief  WIFIڷ
  * @param  cmdַ
	* @param  resڴص
  * @retval 0-ɹ	1-ʧ
	* @note   None
  */
_Bool ESP8266_SendCmd(char *cmd, char *res)
{
	unsigned char timeOut = 200;

	USARTClass.USART_SendString1(ESP8266_UART, (unsigned char *)cmd, strlen((const char *)cmd));

	while(timeOut--)
	{
		// յ
		if(ESP8266_WaitRecive() == REV_OK)							
		{
			// ؼ
			if(strstr((const char *)ESP8266_buf, res) != NULL)
			{
				ESP8266_Clear(); // ջ
				return 0;
			}
		}
		DELAYClass.DelayMs(10);
	}
	return 1;
}
/**
  * @brief  WIFITCP
  * @param  dataַ
	* @param  len
  * @retval None
	* @note   None
  */
void ESP8266_SendData(unsigned char *data, unsigned short len)
{
	char cmdBuf[32];
	
	ESP8266_Clear();								//սջ
	sprintf(cmdBuf, "AT+CIPSEND=%d\r\n", len);		//
	if(!ESP8266_SendCmd(cmdBuf, ">"))				//յ>ʱԷ
	{
		USARTClass.USART_SendString1(ESP8266_UART, data, len);		//豸
	}
}
/**
  * @brief  ȡƽ̨ص
  * @param  timeOutȴʱ(10ms)
  * @retval ƽ̨صԭʼ
	* @note   ͬ豸صĸʽͬҪȥESP8266ķظʽΪ	"+IPD,x:yyy"	xݳȣyyy
  */
unsigned char *ESP8266_GetIPD(unsigned short timeOut)
{
	char *ptrIPD = NULL;
	
	do
	{
		if(ESP8266_WaitRecive() == REV_OK)								//
		{
			ptrIPD = strstr((char *)ESP8266_buf, "IPD,");				//IPDͷ
			if(ptrIPD == NULL)											//ûҵIPDͷӳ٣Ҫȴһᣬᳬ趨ʱ
			{
				//printf( "\"IPD\" not found\r\n");
			}
			else
			{
				ptrIPD = strchr(ptrIPD, ':');							//ҵ':'
				if(ptrIPD != NULL)
				{
					ptrIPD++;
					return (unsigned char *)(ptrIPD);
				}
				else
				{
					return NULL;
				}
			}
		}
		
		DELAYClass.DelayMs(5);													//ʱȴ
	} while(timeOut--);
	
	return NULL;														//ʱδҵؿָ
}
