#include "main.h"
//#include "stm32f10x.h"
//#include "esp8266.h"
//#include "onenet.h"
//#include "mqttkit.h"
//#include "usart.h"
//#include "delay.h"
//#include <string.h>
//#include <stdio.h>


#define PROID			"509223"			// ƷID
#define AUTH_INFO	"0123456789"	// ȨϢ
#define DEVID			"932442653"		// 豸ID

/**
  * @brief  onenet
  * @param  None
  * @retval 1-ɹ	0-ʧ
	* @note   onenetƽ̨
  */
_Bool OneNet_DevLink(void)
{
	MQTT_PACKET_STRUCTURE mqttPacket = {NULL, 0, 0, 0}; // Э
	unsigned char *dataPtr;
	_Bool status = 1;
#ifdef DEBUG_printf
	printf("OneNet_DevLink\n""PROID: %s,	AUIF: %s,	DEVID:%s\n", PROID, AUTH_INFO, DEVID);
#endif
	if(MQTT_PacketConnect(PROID, AUTH_INFO, DEVID, 256, 0, MQTT_QOS_LEVEL0, NULL, NULL, 0, &mqttPacket) == 0)
	{
		ESP8266_SendData(mqttPacket._data, mqttPacket._len);	// ϴƽ̨
		dataPtr = ESP8266_GetIPD(250); // ȴƽ̨Ӧ
		if(dataPtr != NULL)
		{
			if(MQTT_UnPacketRecv(dataPtr) == MQTT_PKT_CONNACK)
			{
				switch(MQTT_UnPacketConnectAck(dataPtr))
				{
					case 0:
						status = 0;
#ifdef DEBUG_printf
						printf("Tips:	ӳɹ\n");
#endif
					break;
					case 1:
#ifdef DEBUG_printf
						printf("WARN:	ʧܣЭ\n");
#endif
					break;
					case 2:
#ifdef DEBUG_printf
						printf("WARN:	ʧܣǷclientid\n");
#endif
					break;
					case 3:
#ifdef DEBUG_printf
						printf("WARN:	ʧܣʧ\n");
#endif
					break;
					case 4:
#ifdef DEBUG_printf
						printf("WARN:	ʧܣû\n");
#endif
					break;
					case 5:
#ifdef DEBUG_printf
						printf("WARN:	ʧܣǷ(tokenǷ)\n");
#endif
					break;
					default:
#ifdef DEBUG_printf
						printf("ERR:	ʧܣδ֪\n");
#endif
					break;
				}
			}
		}
		MQTT_DeleteBuffer(&mqttPacket); // ɾ
	}
	else
	{
#ifdef DEBUG_printf
		printf("WARN:	MQTT_PacketConnect Failed\n");
#endif
	}
	return status;
}
/**
  * @brief  ϴ
  * @param  buf
  * @retval ݳ
	* @note   ֵԸʽŷָ  {key1:99,key2:0}
  */
unsigned char OneNet_FillBuf(char *buf)
{
	char text[128];
	memset(text, 0, sizeof(text));
	
	strcpy(buf, "{");
	/****************user handle********************/
	memset(text, 0, sizeof(text));
	sprintf(text, "\"temp\":%d,", AllFlag.waterTemp);
	strcat(buf, text);
   
	memset(text, 0, sizeof(text));
	sprintf(text, "\"RELAY1\":%d,",AllFlag.relay1_sta);
	strcat(buf, text);

	memset(text, 0, sizeof(text));
	sprintf(text, "\"RELAY2\":%d,",AllFlag.relay2_sta);
	strcat(buf, text);
	
	memset(text, 0, sizeof(text));
	sprintf(text, "\"tempMax\":%d,",AllFlag.waterTempMax);
	strcat(buf, text);
	
	memset(text, 0, sizeof(text));
	sprintf(text, "\"tempMin\":%d",AllFlag.waterTempMin);
	strcat(buf, text);
	/**********************************************/
	strcat(buf, "}");
	
	return strlen(buf);
}
/**
  * @brief  ϴݵOneNETƽ̨
  * @param  None
  * @retval None
  */
void OneNet_SendData(void)
{
	MQTT_PACKET_STRUCTURE mqttPacket = {NULL, 0, 0, 0};	// Э
	char buf[128];
	short body_len = 0, i = 0;
#ifdef DEBUG_printf
	printf("Tips:	OneNet_SendData-MQTT\r\n");
#endif
	memset(buf, 0, sizeof(buf));
	body_len = OneNet_FillBuf(buf); // ȡǰҪ͵ܳ
	if(body_len)
	{
		if(MQTT_PacketSaveData(DEVID, body_len, NULL, 3, &mqttPacket) == 0) // 
		{
			for(; i < body_len; i++) mqttPacket._data[mqttPacket._len++] = buf[i];
			ESP8266_SendData(mqttPacket._data, mqttPacket._len); // ϴݵƽ̨
#ifdef DEBUG_printf
			printf("Send %d Bytes\r\n", mqttPacket._len);
#endif
			MQTT_DeleteBuffer(&mqttPacket); // ɾ
		}
		else
		{
#ifdef DEBUG_printf
			printf("WARN:	EDP_NewBuffer Failed\r\n");
#endif
		}
	}
}
/**
  * @brief  ƽ̨ݼ
  * @param  cmdƽ̨ص
  * @retval None
  */
void OneNet_RevPro(unsigned char *cmd)
{
	MQTT_PACKET_STRUCTURE mqttPacket = {NULL, 0, 0, 0}; // Э
	char *req_payload = NULL;
	char *cmdid_topic = NULL;
	unsigned short req_len = 0;
	unsigned char type = 0;
	short result = 0;
	char *dataPtr = NULL;
	char numBuf[10];
	int num = 0;
	type = MQTT_UnPacketRecv(cmd);
	switch(type)
	{
		case MQTT_PKT_CMD: // ·
			result = MQTT_UnPacketCmd(cmd, &cmdid_topic, &req_payload, &req_len);	// topicϢ
			if(result == 0)
			{
#ifdef DEBUG_printf
				printf("cmdid: %s, req: %s, req_len: %d\r\n", cmdid_topic, req_payload, req_len);
#endif
				if(MQTT_PacketCmdResp(cmdid_topic, req_payload, &mqttPacket) == 0) // ظ
				{
#ifdef DEBUG_printf
					printf("Tips:	Send CmdResp\r\n");
#endif
					ESP8266_SendData(mqttPacket._data, mqttPacket._len); // ظ
					MQTT_DeleteBuffer(&mqttPacket); // ɾ
				}
			}
			break;
		case MQTT_PKT_PUBACK: //PublishϢƽ̨ظAck
			if(MQTT_UnPacketPublishAck(cmd) == 0)
			{
#ifdef DEBUG_printf
				printf("Tips:	MQTT Publish Send OK\r\n");
#endif
			}
			break;
		default:
			result = -1;
		break;
	}
	ESP8266_Clear(); // ջ
	if(result == -1) return ;
	/************************user handle*****************************/
	if(strstr((char *)req_payload, "OPEN1")) // "OPEN1"
	{
#ifdef DEBUG_printf
		printf("OPEN1\n");
#endif
		AllFlag.AutoCtrl_time = 0;
		AllFlag.AutoCtrl_flag = 1;
		GPIOClass.Set(RELAY1);
		// user handle
	}
	if(strstr((char *)req_payload, "CLOSE1")) // "CLOSE1"
	{
		AllFlag.AutoCtrl_time = 0;
		AllFlag.AutoCtrl_flag = 1;
		GPIOClass.Reset(RELAY1);
		// user handle
	}
	if(strstr((char *)req_payload, "OPEN2")) // "OPEN2"
	{
		AllFlag.AutoCtrl_time = 0;
		AllFlag.AutoCtrl_flag = 1;
		GPIOClass.Set(RELAY2);
		// user handle
	}
	if(strstr((char *)req_payload, "CLOSE2")) // "CLOSE2"
	{
		AllFlag.AutoCtrl_time = 0;
		AllFlag.AutoCtrl_flag = 1;
		GPIOClass.Reset(RELAY2);
		// user handle
	}
	
	dataPtr = strchr(req_payload, ':'); // ':'
    
	if(dataPtr != NULL && result != -1) // ҵ
	{
		dataPtr++;
		while(*dataPtr >= '0' && *dataPtr <= '9')	// жǷ·
		{
			numBuf[num++] = *dataPtr++;
		}
		numBuf[num] = 0;
		
		num = atoi((const char *)numBuf); // תΪֵʽ
    /*******************************************************/
    if(strstr((char *)req_payload, "xxx")) // "xxx"
		{
			AllFlag.xxx=num;
#ifdef DEBUG_printf
			printf("xxx:%d\n",num);
#endif
		}
		AllFlag.OneNET_send_flag = 1; // ͱ־λ
      
  }
	if(type == MQTT_PKT_CMD || type == MQTT_PKT_PUBLISH)
	{
		MQTT_FreeBuffer(cmdid_topic);
		MQTT_FreeBuffer(req_payload);
	}
}
