#include "main.h"

static void SG90_TIM_Init(void);
static void SG90_Angle(float angle);
static void SG90_Angle2(float angle);

SG90ClassStruct SG90Class = {
	SG90_TIM_Init,
	SG90_Angle,
	SG90_Angle2
};
// ʹĸͨ
#define USE_TIM_CH1
#define USE_TIM_CH2

#if 0
#define SG90_TIM						TIM2
#define SG90_TIM_CLK					RCC_APB1Periph_TIM2
#define SG90_GPIO_PORT    				GPIOA
#define SG90_GPIO_CLK 	    			RCC_APB2Periph_GPIOA
#ifdef USE_TIM_CH1
#define SG90_GPIO_PIN					GPIO_Pin_0
#endif
#ifdef USE_TIM_CH2
#define SG90_GPIO_PIN2					GPIO_Pin_1
#endif
#else
#define SG90_TIM						TIM3
#define SG90_TIM_CLK					RCC_APB1Periph_TIM3
#define SG90_GPIO_PORT    				GPIOA
#define SG90_GPIO_CLK 	    			RCC_APB2Periph_GPIOA
#ifdef USE_TIM_CH1
#define SG90_GPIO_PIN					GPIO_Pin_6
#endif
#ifdef USE_TIM_CH2
#define SG90_GPIO_PIN2					GPIO_Pin_7
#endif
#endif

// PWMʼ 10000-1,144-1
static void SG90_TIM_Init(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;
	TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure;
	TIM_OCInitTypeDef  TIM_OCInitStructure;

	RCC_APB2PeriphClockCmd(SG90_GPIO_CLK, ENABLE);  //ʹGPIOʱʹ
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO, ENABLE);
	RCC_APB1PeriphClockCmd(SG90_TIM_CLK, ENABLE); //ʱʹ
	
	//øΪ,PWM岨
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;  //
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
#ifdef USE_TIM_CH1
	GPIO_InitStructure.GPIO_Pin = SG90_GPIO_PIN;
	GPIO_Init(SG90_GPIO_PORT, &GPIO_InitStructure);
#endif
#ifdef USE_TIM_CH2
	GPIO_InitStructure.GPIO_Pin = SG90_GPIO_PIN2;
	GPIO_Init(SG90_GPIO_PORT, &GPIO_InitStructure);
#endif
	
	//ʱʼ
	TIM_TimeBaseStructure.TIM_Period = 10000-1; //һ¼װԶװؼĴڵֵ	
	TIM_TimeBaseStructure.TIM_Prescaler = 144-1; //ΪTIMxʱƵʳԤƵֵ
	TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1; //ʱӷָ:TDTS = Tck_tim
	TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;  //TIMϼģʽ
	TIM_TimeBaseStructure.TIM_RepetitionCounter = 0;
	TIM_TimeBaseInit(SG90_TIM, &TIM_TimeBaseStructure); //ָĲʼTIMxʱλ
 
	TIM_OCInitStructure.TIM_OCMode = TIM_OCMode_PWM2; //ѡʱģʽ:TIMȵģʽ2
	TIM_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable; //Ƚʹ
	TIM_OCInitStructure.TIM_Pulse = 0; //ôװ벶ȽϼĴֵ
	TIM_OCInitStructure.TIM_OCPolarity = TIM_OCPolarity_Low; //:TIMȽϼԸ
#ifdef USE_TIM_CH1
	TIM_OC1Init(SG90_TIM, &TIM_OCInitStructure);  //TIM_OCInitStructָĲʼTIMx
	TIM_OC1PreloadConfig(SG90_TIM, TIM_OCPreload_Enable);  	//CH1Ԥװʹ   
#endif	
#ifdef USE_TIM_CH2
	TIM_OC2Init(SG90_TIM, &TIM_OCInitStructure);
	TIM_OC2PreloadConfig(SG90_TIM, TIM_OCPreload_Enable);
#endif
	TIM_ARRPreloadConfig(SG90_TIM, ENABLE); //ʹTIMxARRϵԤװؼĴ
	TIM_Cmd(SG90_TIM, ENABLE);  //ʹTIMx
	TIM_CtrlPWMOutputs(SG90_TIM,ENABLE);  //MOE ʹ				 
}
// CH1Ƕ
static void SG90_Angle(float angle)
{
	angle = (uint16_t)(50.0 * angle / 9.0 + 250.0);
	TIM_SetCompare1(SG90_TIM, angle);
}
// CH2Ƕ
static void SG90_Angle2(float angle)
{
	angle = (uint16_t)(50.0 * angle / 9.0 + 250.0);
	TIM_SetCompare2(SG90_TIM, angle);
}
