#include "main.h"
//#include "WIFI_config.h"
//#include "WIFI_func.h"
//#include "cJSON.h"

static uint8_t weatherCJSON_handle(char s[], WIFIWeatherStruct *WIFIWeather1);
static uint8_t timeCJSONToString(char s[], uint8_t *timeBuff1, uint8_t hexOrDec1);
static void timeJsonTotimeInt(char *str1, uint8_t *timeBuff2, uint8_t hexOrDec2);
static int stringToInt(char *str);


/**
  * @brief  WIFIʼ
  * @param  None
  * @retval None
  * @note   None
	*/
void WIFI_Init(void)
{
	mem_init();
	WIFI_USART_Init(115200);
	WIFI_TIM3_Init();
}
/**
  * @brief  WIFI
  * @param  None
  * @retval None
  * @note   None
	*/
void WIFI_Connect(void)
{
	WIFI_RESET_GPIO_Congfig();
	ESP8266_clear();
	ESP8266_quit_trans(); // ر͸TCPģʽ
	Connect_wifi();
}
/**
  * @brief  WIFIȡʵʱʱ
	* @param  timeBuff: ʱŵַ
	* @param  hexOrDec: תΪʮƱʾʮƱʾ 1610
	* @retval 0: ɹ
  * @note   None
	*/
uint8_t WIFI_RealTime_handle(uint8_t *timeBuff, uint8_t hexOrDec)
{
	uint8_t result = 1;
	Connect_time_port();
	result = timeCJSONToString(WIFI_USART_RX_BUF, timeBuff, hexOrDec);
	ESP8266_quit_trans(); // ڽ֮
	return result;
}
/**
  * @brief  WIFIȡʵʱ
  * @param  None
  * @retval None
  * @note   None
	*/
uint8_t WIFI_realWeather_handle(WIFIWeatherStruct *WIFIWeather1)
{
	uint8_t result = 1;
	Connect_wea_port();
	result = weatherCJSON_handle(WIFI_USART_RX_BUF, WIFIWeather1);
	ESP8266_quit_trans(); // ڽ֮
	return result;
}
/**
  * @brief  WIFICJSONݴ
  * @param  None
  * @retval None
  * @note   CJSONתΪݸʽ
	*/
static uint8_t weatherCJSON_handle(char s[], WIFIWeatherStruct *WIFIWeather2)
{
	uint8_t result = 1;
	char t[] ="[";
	char r[] ="]";
	cJSON *res,*location, *tq ,*qw, *name, *now;
	cJSON *cjson;
	Delete_char(s,t[0]);
	Delete_char(s,r[0]);
	cjson = cJSON_Parse(s);
	if(cjson)
	{
		res = cJSON_GetObjectItem(cjson, "results");
		location = cJSON_GetObjectItem(res, "location");
		name = cJSON_GetObjectItem(location, "name");
		now = cJSON_GetObjectItem(res, "now");
		tq = cJSON_GetObjectItem(now, "code");
		qw = cJSON_GetObjectItem(now, "temperature");
		WIFIWeather2->weatherCode = stringToInt(tq->valuestring);
		WIFIWeather2->weatherTemp[0] = *(qw->valuestring);
		WIFIWeather2->weatherTemp[1] = *((qw->valuestring) + 1);
		WIFIWeather2->weatherTemp[2] = '\0';
		if(WIFIWeather2->weatherTemp[0] < '0') WIFIWeather2->tempNum = 0;
		else WIFIWeather2->tempNum = stringToInt(qw->valuestring);
		result = 0;
#ifdef DEBUG_printf
	printf("cityName is %s\n",name->valuestring);
	printf("tianqi is %s\n",tq->valuestring);
	printf("tem is %s\n",qw->valuestring);
#endif
	}
	cJSON_Delete(cjson);
	myfree(s);
	return result;
}
/**
  * @brief  ʱjsonתstring
	* @param  s[]:json
	* @param  timeBuff1: ʱŵַ
	* @param  hexOrDec1: תΪʮƱʾʮƱʾ 1610
	* @retval 0: ɹ
  * @note   None
*/
static uint8_t timeCJSONToString(char s[], uint8_t *timeBuff1, uint8_t hexOrDec1)
{
	uint8_t result = 1;
	cJSON *res, *time, *week;
	cJSON *cjson;
	cjson = cJSON_Parse(s);
	if(cjson)
	{
		res = cJSON_GetObjectItem(cjson, "result");
		time = cJSON_GetObjectItem(res, "datetime_1");
		week = cJSON_GetObjectItem(res, "week_1");
		if(stringToInt(week->valuestring) == 0) {
			WIFITimeData[7] = 0x07;
		} else {
			WIFITimeData[7] = stringToInt(week->valuestring);
		}
		// ΪintʼDS1302
		timeJsonTotimeInt(time->valuestring, timeBuff1, hexOrDec1);
		result = 0;
#ifdef DEBUG_printf
		printf("WIFI time: datetime is %s; week is %s\n", time->valuestring, week->valuestring);
#endif
	}
	cJSON_Delete(cjson);
	myfree(s);
	return result;
}

/**
  * @brief  jsonеtime
	* @param  str1:ַַ
	* @param  timeBuff2: ʱŵַ
	* @param  hexOrDec2: תΪʮƱʾʮƱʾ 1610
  * @retval None
  * @note   None
*/
static void timeJsonTotimeInt(char *str1, uint8_t *timeBuff2, uint8_t hexOrDec2)
{
	char *str = str1;
	char temp[5];
	char i = 0,j = 0;
	int timeTemp = 0;
	memset(temp, 0, sizeof(temp)/sizeof(temp[0]));
	for(j = 0; j < 6; j ++) {
		while(*str != '-' && *str != ' ' && *str != ':') {
			if(*str == '\0') break;
			temp[i] = *str;
			i++;
			str++;
		}
		timeTemp = stringToInt(temp);
		switch(j) {
			case 0:
				timeBuff2[0] = timeTemp/100/10*hexOrDec2 + timeTemp/100%10;
				timeBuff2[1] = timeTemp%100/10*hexOrDec2 + timeTemp%100%10;
				break;
			case 1:
				timeBuff2[2] = timeTemp/10*hexOrDec2 + timeTemp%10;
				break;
			case 2:
				timeBuff2[3] = timeTemp/10*hexOrDec2 + timeTemp%10;
				break;
			case 3:
				timeBuff2[4] = timeTemp/10*hexOrDec2 + timeTemp%10;
				break;
			case 4:
				timeBuff2[5] = timeTemp/10*hexOrDec2 + timeTemp%10;
				break;
			case 5:
				timeBuff2[6] = timeTemp/10*hexOrDec2 + timeTemp%10 + 2; // 2sʱ
				break;
		}
		memset(temp, 0, sizeof(temp)/sizeof(temp[0]));
		i = 0;
		str++;
	}
#ifdef DEBUG_printf
	if(hexOrDec2 == 16)
	{
		printf("timeBuff: %x%x-%x-%x %x:%x:%x %x\n", timeBuff2[0], timeBuff2[1], timeBuff2[2], timeBuff2[3], timeBuff2[4], timeBuff2[5], timeBuff2[6], timeBuff2[7]);
	}
	else if(hexOrDec2 == 10)
	{
		printf("timeBuff: %d%d-%d-%d %d:%d:%d %d\n", timeBuff2[0], timeBuff2[1], timeBuff2[2], timeBuff2[3], timeBuff2[4], timeBuff2[5], timeBuff2[6], timeBuff2[7]);
	}
	#endif
}
/**
  * @brief  stringתint
	* @param  *str:ַַ
  * @retval int
  * @note   None
*/
static int stringToInt(char *str)
{
	char *p = str;
	int nNUM = 0;
	
	while (*p != '\0')
	{
		nNUM = nNUM * 10 + (*p - '0');
		p++;
	}
	return nNUM;
}
/**
  * @brief  ʾ
	* @param  temp:
  * @retval None
  * @note   None
*/
void tianqiDisplay(uint8_t weatherCode)
{
	uint8_t x1 = 48;
	uint8_t x2 = 64;
	uint8_t y = 4;
	if(weatherCode <= 3) {
		OLED_ShowChinese(x1,y,27); // 
		OLED_ShowString(x2,y,"  ",16);
	} else if(weatherCode <= 8) {
		OLED_ShowChinese(x1,y,28); // 
		OLED_ShowChinese(x2,y,29);
	} else if(weatherCode == 9) {
		OLED_ShowChinese(x1,y,30); // 
		OLED_ShowString(x2,y,"  ",16);
	} else if(weatherCode == 10) {
		OLED_ShowChinese(x1,y,36); // 
		OLED_ShowChinese(x2,y,31);
	} else if(weatherCode <= 12) {
		OLED_ShowChinese(x1,y,35); // 
		OLED_ShowChinese(x2,y,31);
	} else if(weatherCode == 13) {
		OLED_ShowChinese(x1,y,34); // С
		OLED_ShowChinese(x2,y,31);
	} else if(weatherCode == 14) {
		OLED_ShowChinese(x1,y,33); // 
		OLED_ShowChinese(x2,y,31);
	} else if(weatherCode <= 19) {
		OLED_ShowChinese(x1,y,32); // 
		OLED_ShowChinese(x2,y,31);
	} else if(weatherCode <= 21) {
		OLED_ShowChinese(x1,y,36); // ѩ
		OLED_ShowChinese(x2,y,39);
	} else if(weatherCode == 22) {
		OLED_ShowChinese(x1,y,34); // Сѩ
		OLED_ShowChinese(x2,y,39);
	} else if(weatherCode == 23) {
		OLED_ShowChinese(x1,y,33); // ѩ
		OLED_ShowChinese(x2,y,39);
	} else if(weatherCode <= 25) {
		OLED_ShowChinese(x1,y,32); // ѩ
		OLED_ShowChinese(x2,y,39);
	} else if(weatherCode == 30) {
		OLED_ShowChinese(x1,y,37); // 
		OLED_ShowString(x2,y,"  ",16);
	} else if(weatherCode == 31) {
		OLED_ShowChinese(x1,y,38); // 
		OLED_ShowString(x2,y,"  ",16);
	} else {
		OLED_ShowString(x1,y,"N/A ",16); // N/A
	}
}
