#include "main.h"

static void mymemcpy(void *des,void *src,uint32_t n);
static void mymemset(void *s,uint8_t c,uint32_t count);
static uint8_t mem_perused(void);

#ifndef NULL
#define NULL 0
#endif
#define MEM_BLOCK_SIZE			  32  	  					          	//ڴСΪ32ֽ
#define MEM_MAX_SIZE			    2048  						        		//ڴ 2K
#define MEM_ALLOC_TABLE_SIZE	MEM_MAX_SIZE/MEM_BLOCK_SIZE 	//ڴС

//ڴ(4ֽڶ)
__align(4) uint8_t membase[MEM_MAX_SIZE];							//ڲSRAMڴ
//ڴ
uint16_t memmapbase[MEM_ALLOC_TABLE_SIZE];						//ڲSRAMڴMAP
//ڴ	   
const uint32_t memtblsize = MEM_ALLOC_TABLE_SIZE;			//ڴС
const uint32_t memblksize = MEM_BLOCK_SIZE;						//ڴֿС
const uint32_t memsize    = MEM_MAX_SIZE;							//ڴܴС

//ڴ
struct _m_mallco_dev mallco_dev=
{
	mem_init,				//ڴʼ
	mem_perused,	  //ڴʹ
	membase,		    //ڴ
	memmapbase,     //ڴ״̬
	0,  					  //ڴδ
};

//ڴ
//*des:Ŀĵַ
//*src:Դַ
//n:ҪƵڴ泤(ֽΪλ)
static void mymemcpy(void *des,void *src,uint32_t n)  
{  
  uint8_t *xdes=des;
	uint8_t *xsrc=src; 
  while(n--)*xdes++=*xsrc++;  
}  

//ڴ
//*s:ڴ׵ַ
//c :Ҫõֵ
//count:ҪõڴС(ֽΪλ)
static void mymemset(void *s,uint8_t c,uint32_t count)  
{  
    uint8_t *xs = s;  
    while(count--)*xs++=c;  
}	
 
//ȡڴʹ
//memx:ڴ
//ֵ:ʹ(0~100)
static uint8_t mem_perused(void)  
{  
    uint32_t used=0;  
    uint32_t i;  
    for(i=0;i<memtblsize;i++)  
    {  
        if(mallco_dev.memmap[i])used++; 
    } 
    return (used*100)/(memtblsize);  
}  

//ڴ(ڲ)
//memx:ڴ
//size:ҪڴС(ֽ)
//ֵ:0XFFFFFFFF,;,ڴƫƵַ 
static uint32_t mem_malloc(uint32_t size)  
{  
    signed long offset=0;  
    uint16_t nmemb;	//Ҫڴ  
	uint16_t cmemb=0;//ڴ
    uint32_t i;  
    if(!mallco_dev.memrdy)mallco_dev.init();//δʼ,ִгʼ 
    if(size==0)return 0XFFFFFFFF;//Ҫ

    nmemb=size/memblksize;  	//ȡҪڴ
    if(size%memblksize)nmemb++;  
    for(offset=memtblsize-1;offset>=0;offset--)//ڴ  
    {     
		if(!mallco_dev.memmap[offset])cmemb++;//ڴ
		else cmemb=0;								//ڴ
		if(cmemb==nmemb)							//ҵnmembڴ
		{
            for(i=0;i<nmemb;i++)  					//עڴǿ 
            {  
                mallco_dev.memmap[offset+i]=nmemb;  
            }  
            return (offset*memblksize);//ƫƵַ  
		}
    }  
    return 0XFFFFFFFF;//δҵϷڴ  
}  

//ͷڴ(ڲ) 
//memx:ڴ
//offset:ڴַƫ
//ֵ:0,ͷųɹ;1,ͷʧ;  
static uint8_t mem_free(uint32_t offset)  
{  
    int i;  
    if(!mallco_dev.memrdy)//δʼ,ִгʼ
	{
		mallco_dev.init();    
        return 1;//δʼ  
    }  
    if(offset<memsize)//ƫڴ. 
    {  
        int index=offset/memblksize;			//ƫڴ  
        int nmemb=mallco_dev.memmap[index];	//ڴ
        for(i=0;i<nmemb;i++)  						//ڴ
        {  
            mallco_dev.memmap[index+i]=0;  
        }  
        return 0;  
    }else return 2;//ƫƳ.  
}  
//ڴʼ  
//memx:ڴ
void mem_init(void)  
{  
  mymemset(mallco_dev.memmap, 0,memtblsize*2);//ڴ״̬  
	mymemset(mallco_dev.membase, 0,memsize);	//ڴ  
	mallco_dev.memrdy=1;								//ڴʼOK  
}
//ͷڴ(ⲿ) 
//memx:ڴ
//ptr:ڴ׵ַ 
void myfree(void *ptr)  
{  
	uint32_t offset;  
    if(ptr==NULL)return;//ַΪ0.  
 	offset=(uint32_t)ptr-(uint32_t)mallco_dev.membase;  
    mem_free(offset);//ͷڴ     
}

//ڴ(ⲿ)
//memx:ڴ
//size:ڴС(ֽ)
//ֵ:䵽ڴ׵ַ.
void *mymalloc(uint32_t size)  
{  
    uint32_t offset;  									      
	offset=mem_malloc(size);  	   				   
    if(offset==0XFFFFFFFF)return NULL;  
    else return (void*)((uint32_t)mallco_dev.membase+offset);  
}  

//·ڴ(ⲿ)
//memx:ڴ
//*ptr:ڴ׵ַ
//size:ҪڴС(ֽ)
//ֵ:·䵽ڴ׵ַ.
void *myrealloc(void *ptr,uint32_t size)  
{  
    uint32_t offset;  
    offset=mem_malloc(size);  
    if(offset==0XFFFFFFFF)return NULL;     
    else  
    {  									   
	    mymemcpy((void*)((uint32_t)mallco_dev.membase+offset),ptr,size);	//ڴݵڴ   
        myfree(ptr);  											  		//ͷžڴ
        return (void*)((uint32_t)mallco_dev.membase+offset);  				//ڴ׵ַ
    }  
}  
