#include "can.h"
#include <string.h>

/**
  * @brief  CAN
  * @param  
  * @retval None
	* @note		tsjw:ͬԾʱ䵥Ԫ.Χ:1~3;	CAN_SJW_1tq	CAN_SJW_2tq	CAN_SJW_3tq	CAN_SJW_4tq
			tbs2:ʱ2ʱ䵥Ԫ.Χ:1~8;
			tbs1:ʱ1ʱ䵥Ԫ.Χ:1~16;	  CAN_BS1_1tq ~CAN_BS1_16tq
			brp :ʷƵ.Χ:1~1024;(ʵҪ1,Ҳ1~1024) tq=(brp)*tpclk1
			עϲκһΪ0,.
			=Fpclk1/((tsjw+tbs1+tbs2)*brp);
			mode:0,ͨģʽ;1,ػģʽ;
			Fpclk1ʱڳʼʱΪ36M,CAN_Normal_Init(1,8,7,5,1);
			Ϊ:36M/((1+8+7)*5)=450Kbps
  */
u8 CAN_Mode_Init(u8 tsjw,u8 tbs1,u8 tbs2,u16 brp,u8 mode)
{
	GPIO_InitTypeDef GPIO_InitStructure;
	CAN_InitTypeDef CAN_InitStructure;
 	CAN_FilterInitTypeDef CAN_FilterInitStructure;
	NVIC_InitTypeDef NVIC_InitStructure;
	
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA | RCC_APB2Periph_AFIO, ENABLE); //ʹPORTAʱ                											 
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_CAN1, ENABLE); //ʹCAN1ʱ
	// CAN_Tx
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;	//
	GPIO_Init(GPIOA, &GPIO_InitStructure);			//ʼIO
	// CAN_Rx
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_11;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;	//
	GPIO_Init(GPIOA, &GPIO_InitStructure);			//ʼIO
	
	//CANԪ MCR
 	CAN_InitStructure.CAN_TTCM=DISABLE;	//ʱ䴥ͨģʽ  //
 	CAN_InitStructure.CAN_ABOM=ENABLE;	//Զ߹	 //
	CAN_InitStructure.CAN_AWUM=DISABLE;	//˯ģʽͨ(CAN->MCRSLEEPλ)//
	CAN_InitStructure.CAN_NART=ENABLE;	//ֹԶ //ֻһΣܳɹ
	CAN_InitStructure.CAN_RFLM=DISABLE;	//Ĳ,µĸǾɵ // 
	CAN_InitStructure.CAN_TXFP=DISABLE;	//ȼɱıʶ //
	//CAN1
	CAN_InitStructure.CAN_Mode= mode;	//ģʽã mode:0,ͨģʽ;1,ػģʽ; //
	CAN_InitStructure.CAN_SJW=tsjw;		//ͬԾ(Tsjw)Ϊtsjw+1ʱ䵥λ  CAN_SJW_1tq	 CAN_SJW_2tq CAN_SJW_3tq CAN_SJW_4tq
	CAN_InitStructure.CAN_BS1=tbs1;	 	//Tbs1=tbs1+1ʱ䵥λCAN_BS1_1tq ~CAN_BS1_16tq
	CAN_InitStructure.CAN_BS2=tbs2;		//Tbs2=tbs2+1ʱ䵥λCAN_BS2_1tq ~	CAN_BS2_8tq
	CAN_InitStructure.CAN_Prescaler=brp;//Ƶϵ(Fdiv)Ϊbrp+1	//
	CAN_Init(CAN1, &CAN_InitStructure);
	//˲0
	CAN_FilterInitStructure.CAN_FilterNumber=0;	  						//0 28
	CAN_FilterInitStructure.CAN_FilterMode=CAN_FilterMode_IdMask; 		//־λIDģʽ CAN_FilterMode_IdList
	CAN_FilterInitStructure.CAN_FilterScale=CAN_FilterScale_32bit; 		//32λ CAN_FilterScale_16bit
//	CAN_FilterInitStructure.CAN_FilterIdHigh=0x111<<5;							//32λID //ID뵽STID
//	CAN_FilterInitStructure.CAN_FilterIdLow=0|CAN_ID_STD;	
//	CAN_FilterInitStructure.CAN_FilterMaskIdHigh=0x222<<5;						//32λMASK
//	CAN_FilterInitStructure.CAN_FilterMaskIdLow=0|CAN_ID_STD;
	CAN_FilterInitStructure.CAN_FilterIdHigh=0x0000;							//32λID //ID뵽STID
	CAN_FilterInitStructure.CAN_FilterIdLow=0x0000;	
	CAN_FilterInitStructure.CAN_FilterMaskIdHigh=0x0000;						//32λMASK
	CAN_FilterInitStructure.CAN_FilterMaskIdLow=0x0000;
	CAN_FilterInitStructure.CAN_FilterFIFOAssignment=CAN_Filter_FIFO0;	//0FIFO0
	CAN_FilterInitStructure.CAN_FilterActivation=ENABLE; 				//0
	CAN_FilterInit(&CAN_FilterInitStructure);							//˲ʼ
	
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_4);

	NVIC_InitStructure.NVIC_IRQChannel = USB_LP_CAN1_RX0_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;     		// ȼΪ1
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;            		// ȼΪ0
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure);
	
	CAN_ITConfig(CAN1,CAN_IT_FMP0,ENABLE);								//FIFO0ϢҺж
	return 0;
}
u8 canbuff[8];
//CAN1жϷ			    
void USB_LP_CAN1_RX0_IRQHandler(void)
{
  CanRxMsg RxMessage;
	
  CAN_Receive(CAN1, CAN_FIFO0, &RxMessage);
	
	if(RxMessage.StdId == 0x200)
	{
		memcpy(canbuff,RxMessage.Data,8);
	}
}
//len:ݳ(Ϊ8)				     
//msg:ָ,Ϊ8ֽ.
//ֵ:0,ɹ;
//		 ,ʧ;
u8 Can_Send_Msg(u32 canid,u8* msg,u8 len)
{	
	u8 mbox;
	u16 i=0;
	CanTxMsg TxMessage;
	TxMessage.StdId=canid;			// ׼ʶΪ0
	TxMessage.ExtId=0x1012;			// չʾ29λ
	TxMessage.IDE=CAN_Id_Standard;	// ʹչʶ
	TxMessage.RTR=CAN_RTR_Data;		// ϢΪ֡һ֡8λ
	TxMessage.DLC=len;				// ֡Ϣ
	for(i=0;i<len;i++)
	TxMessage.Data[i]=msg[i];		// һ֡Ϣ          
	mbox= CAN_Transmit(CAN1, &TxMessage);   
	i=0;
	while((CAN_TransmitStatus(CAN1, mbox)!=CAN_TxStatus_Ok)&&(i<0XFFF))i++;	//ȴͽ
	if(i>=0XFFF)return 1;
	return 0;		

}

