#include "main.h"

static void GPIO_Config(void);
static void GPIO_Set(uint8_t who);
static void GPIO_Reset(uint8_t who);
static void GPIO_Toggle(uint8_t who);
static uint8_t GPIO_Get(uint8_t who);

GPIOClassStruct GPIOClass = {
	.Init = GPIO_Config,
	.Set = GPIO_Set,
	.Reset = GPIO_Reset,
	.Toggle = GPIO_Toggle,
	.Read = GPIO_Get
};

// LEDRun
#define LEDRun_GPIO_PORT    			GPIOB			              /* GPIO˿ */
#define LEDRun_GPIO_CLK 	    		RCC_APB2Periph_GPIOB		/* GPIO˿ʱ */
#define LEDRun_GPIO_PIN						GPIO_Pin_5			        /* ӵSCLʱߵGPIO */
#define LEDRun_GPIO_TOGGLE		 		LEDRun_GPIO_PORT->BSRR = ((LEDRun_GPIO_PORT->ODR & LEDRun_GPIO_PIN) << 16) | (~LEDRun_GPIO_PORT->ODR & LEDRun_GPIO_PIN)
#define LEDRun_GPIO_SET			   		LEDRun_GPIO_PORT->BSRR = (uint32_t)LEDRun_GPIO_PIN // 1
#define LEDRun_GPIO_RESET		   		LEDRun_GPIO_PORT->BSRR = (uint32_t)LEDRun_GPIO_PIN<<16 // 0
#define LEDRun_GPIO_READ					((LEDRun_GPIO_PORT->IDR & LEDRun_GPIO_PIN) != 0)
// FAN
#define FAN_GPIO_PORT    					GPIOB			              /* GPIO˿ */
#define FAN_GPIO_CLK 	    				RCC_APB2Periph_GPIOB		/* GPIO˿ʱ */
#define FAN_GPIO_PIN							GPIO_Pin_9			        /* ӵSCLʱߵGPIO */
#define FAN_GPIO_TOGGLE		 				FAN_GPIO_PORT->BSRR = ((FAN_GPIO_PORT->ODR & FAN_GPIO_PIN) << 16) | (~FAN_GPIO_PORT->ODR & FAN_GPIO_PIN)
#define FAN_GPIO_SET			   			FAN_GPIO_PORT->BSRR = (uint32_t)FAN_GPIO_PIN // 1
#define FAN_GPIO_RESET		   			FAN_GPIO_PORT->BSRR = (uint32_t)FAN_GPIO_PIN<<16 // 0
#define FAN_GPIO_READ							((FAN_GPIO_PORT->IDR & FAN_GPIO_PIN) != 0)

/**
  * @brief  IO
  * @param  None
  * @retval None
  */
static void GPIO_Config(void)
{		
	/*һGPIO_InitTypeDef͵Ľṹ*/
	GPIO_InitTypeDef GPIO_InitStructure;
	
	/*LEDصGPIOʱ*/
	RCC_APB2PeriphClockCmd(LEDRun_GPIO_CLK | RCC_APB2Periph_AFIO, ENABLE);
	GPIO_PinRemapConfig(GPIO_Remap_SWJ_JTAGDisable, ENABLE);
	GPIO_InitStructure.GPIO_Pin = LEDRun_GPIO_PIN;	
	/*ģʽΪ*/
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;   
	/**/   
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz; 
	/*ÿ⺯ʼGPIO*/
	GPIO_Init(LEDRun_GPIO_PORT, &GPIO_InitStructure);	
	/*ر*/
	LEDRun_GPIO_SET;
	
	RCC_APB2PeriphClockCmd(FAN_GPIO_CLK, ENABLE);
	GPIO_InitStructure.GPIO_Pin = FAN_GPIO_PIN;	
	GPIO_Init(FAN_GPIO_PORT, &GPIO_InitStructure);	
	FAN_GPIO_SET;
}
/**
  * @brief  IOø
  * @param  None
  * @retval None
  */
static void GPIO_Set(uint8_t who)
{
	switch(who)
	{
		case LED_Run: LEDRun_GPIO_SET;break;
		case FAN: FAN_GPIO_SET;break;
	}
}
/**
  * @brief  IOõ
  * @param  None
  * @retval None
  */
static void GPIO_Reset(uint8_t who)
{
	switch(who)
	{
		case LED_Run: LEDRun_GPIO_RESET;break;
		case FAN: FAN_GPIO_RESET;break;
	}
}
/**
  * @brief  IOת
  * @param  None
  * @retval None
  */
static void GPIO_Toggle(uint8_t who)
{
	switch(who)
	{
		case LED_Run: LEDRun_GPIO_TOGGLE;break;
		case FAN: FAN_GPIO_TOGGLE;break;
	}
}
/**
  * @brief  IOȡ
  * @param  None
  * @retval None
  */
static uint8_t GPIO_Get(uint8_t who)
{
	uint8_t temp = 0;
	switch(who)
	{
		case LED_Run: temp = LEDRun_GPIO_READ;break;
		case FAN: temp = FAN_GPIO_READ;break;
	}
	return temp;
}
