#include "main.h"


#define IIC_SDA_PORT		GPIOA
#define IIC_SDA_CLK			(RCC_APB2Periph_GPIOA)
#define IIC_SDA_PIN			GPIO_Pin_5
#define IIC_SCL_PORT		GPIOA
#define IIC_SCL_CLK			(RCC_APB2Periph_GPIOA)
#define IIC_SCL_PIN			GPIO_Pin_6

#define IIC_SCL_OUT_1		IIC_SCL_PORT->BSRR = (uint32_t)IIC_SCL_PIN // 1
#define IIC_SCL_OUT_0		IIC_SCL_PORT->BRR = (uint32_t)IIC_SCL_PIN
#define IIC_SDA_OUT_1		IIC_SDA_PORT->BSRR = (uint32_t)IIC_SDA_PIN // 1
#define IIC_SDA_OUT_0		IIC_SDA_PORT->BRR = (uint32_t)IIC_SDA_PIN
#define IIC_SDA_IN()		((IIC_SDA_PORT->IDR & IIC_SDA_PIN) != 0)

/**
  * @brief  IICʱ
  * @param  None
  * @retval None
  */
static void IIC_Delay(void)
{
	uint8_t i;
	/*
	 	ʱͨ߼ǲԵõġ
    CPUƵ72MHz MDK뻷1Ż
  
		ѭΪ10ʱSCLƵ = 205KHz 
		ѭΪ7ʱSCLƵ = 347KHz SCLߵƽʱ1.5usSCL͵ƽʱ2.87us 
	 	ѭΪ5ʱSCLƵ = 421KHz SCLߵƽʱ1.25usSCL͵ƽʱ2.375us 
	*/
	for (i = 0; i < 10; i++);
}
/**
  * @brief  SDA
  * @param  None
  * @retval None
  */
void Set_IIC_SDA_OUT(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;	
	RCC_APB2PeriphClockCmd(IIC_SDA_CLK, ENABLE);
	GPIO_InitStructure.GPIO_Pin=IIC_SDA_PIN;
	GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode=GPIO_Mode_Out_OD;
	GPIO_Init(IIC_SDA_PORT,&GPIO_InitStructure); 						
}
/**
  * @brief  SDA뷽
  * @param  None
  * @retval None
  */
void Set_IIC_SDA_IN(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;	
	RCC_APB2PeriphClockCmd(IIC_SDA_CLK, ENABLE);
	GPIO_InitStructure.GPIO_Pin=IIC_SDA_PIN;
	GPIO_InitStructure.GPIO_Mode=GPIO_Mode_IPU;
	GPIO_Init(IIC_SDA_PORT,&GPIO_InitStructure);
}
/**
  * @brief  ģIICʼ
  * @param  None
  * @retval None
  */
void IIC_init()
{
	GPIO_InitTypeDef  GPIO_InitStructure;
	RCC_APB2PeriphClockCmd(IIC_SDA_CLK | IIC_SCL_CLK, ENABLE);
	GPIO_InitStructure.GPIO_Pin = IIC_SDA_PIN;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_OD; 		
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;	
	GPIO_Init(IIC_SDA_PORT, &GPIO_InitStructure);	
	GPIO_InitStructure.GPIO_Pin = IIC_SCL_PIN;
	GPIO_Init(IIC_SCL_PORT, &GPIO_InitStructure);	
	IIC_stop();
}
/**
  * @brief  ģIICʼź
  * @param  None
  * @retval None
  */
void IIC_start()
{
	Set_IIC_SDA_OUT();
	IIC_SCL_OUT_1;
	IIC_SDA_OUT_1;
	IIC_Delay();
	IIC_SDA_OUT_0;
	IIC_Delay();
	IIC_SCL_OUT_0;
	IIC_Delay();
}
/**
  * @brief  ģIICֹͣź
  * @param  None
  * @retval None
  */
void IIC_stop()
{
	Set_IIC_SDA_OUT();
	IIC_SCL_OUT_1;
	IIC_SDA_OUT_0;
	IIC_Delay();
	IIC_SDA_OUT_1;
}
/**
  * @brief  ģIICӦ
  * @param  None
  * @retval None
  */
void IIC_ack()
{
	Set_IIC_SDA_OUT();
  IIC_SDA_OUT_0;
	IIC_Delay();
	IIC_SCL_OUT_1;
	IIC_Delay();
	IIC_SCL_OUT_0;
	IIC_Delay();	
	IIC_SDA_OUT_1;
}
/**
  * @brief  ģIICӦ
  * @param  None
  * @retval None
  */
void IIC_noack()
{
	Set_IIC_SDA_OUT();
  IIC_SDA_OUT_1;
	IIC_Delay();
	IIC_SCL_OUT_1;
	IIC_Delay();
	IIC_SCL_OUT_0;
	IIC_Delay();
}
/**
  * @brief  ģIICȴӻӦ
  * @param  None
	* @retval 1: Ӧʧ 0: Ӧɹ
  */
uint8_t IIC_wait_ack()
{
	uint8_t rec = 0;
	Set_IIC_SDA_OUT();
	IIC_SDA_OUT_1;
	IIC_Delay();
	Set_IIC_SDA_IN();
	IIC_SCL_OUT_1;
	IIC_Delay();
	rec = IIC_SDA_IN();
	IIC_SCL_OUT_0;
	IIC_Delay();
	
	return rec;
}
/**
	* @brief  ģIICһֽ
  * @param  None
  * @retval None
  */
void IIC_send_byte(uint8_t txd)
{
	uint8_t i=0;
	Set_IIC_SDA_OUT();
	for(i=0;i<8;i++)
	{
		if(txd&0x80) IIC_SDA_OUT_1;
		else IIC_SDA_OUT_0;
		IIC_Delay();
		IIC_SCL_OUT_1;
		IIC_Delay(); // 
		IIC_SCL_OUT_0;
		if(i == 7) IIC_SDA_OUT_1; // һλݷҪͷSDA
		txd <<= 1;
		IIC_Delay();
	}
}
/**
	* @brief  ģIICȡһֽ
	* @param  ack: 0,겻Ӧ 1,Ӧ
  * @retval ضȡֽ
  */
uint8_t IIC_read_byte(uint8_t ack)
{
	uint8_t i,receive=0;
	Set_IIC_SDA_IN();
	for(i=0;i<8;i++)
	{
		receive <<= 1;
		IIC_SCL_OUT_1;
		IIC_Delay();
		if(IIC_SDA_IN()) receive++; // ȡλ
		IIC_SCL_OUT_0;
		IIC_Delay();	
	}
  if(!ack) IIC_noack();
	else IIC_ack();

	return receive; // ضȡֽ
}

	
