#include "main.h"

static void USART1_Init(uint32_t baudRate);
static void USART2_Init(uint32_t baudRate);
static void USART3_Init(uint32_t baudRate);
static void USART_SendString1(USART_TypeDef *USARTx, uint8_t *str, uint16_t len);
static void USART_SendString2(USART_TypeDef* USARTx, uint8_t *str);

USARTClassStruct USARTClass = {
	.USART1_Init = USART1_Init,
	.USART2_Init = USART2_Init,
	.USART3_Init = USART3_Init,
	.USART_SendString1 = USART_SendString1,
	.USART_SendString2 = USART_SendString2
};

#define use_USART1
#define use_USART2
//#define use_USART3
#define DEBUG_USART	USART1

/* ڱĵطִ˺  1жϺ
void USART1_IRQHandler(void)
{
	if(USART_GetITStatus(USART1, USART_IT_RXNE) != RESET) {
		USART_ClearITPendingBit(USART1, USART_IT_RXNE);
	}
}
*/
/* ڱĵطִ˺  2жϺ
void USART2_IRQHandler(void)
{
	if(USART_GetITStatus(USART2, USART_IT_RXNE) != RESET) {
		USART_ClearITPendingBit(USART2, USART_IT_RXNE);
	}
}
*/
/* ڱĵطִ˺  3жϺ
void USART3_IRQHandler(void)
{
	if(USART_GetITStatus(USART3, USART_IT_RXNE) != RESET) {
		USART_ClearITPendingBit(USART3, USART_IT_RXNE);
	}
}
*/

/**
  * @brief  USART1ʼ
  * @param  baudRate: 
  * @retval None
  */
static void USART1_Init(uint32_t baudRate)
{
#ifdef use_USART1
	GPIO_InitTypeDef GPIO_InitStructure;
	USART_InitTypeDef USART_InitStructure;
	NVIC_InitTypeDef NVIC_InitStructure;

	// 򿪴GPIOʱ
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);
	// 򿪴ʱ
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1, ENABLE);

	// USART TxGPIOΪ츴ģʽ
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOA, &GPIO_InitStructure);
  // USART RxGPIOΪģʽ
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
	GPIO_Init(GPIOA, &GPIO_InitStructure);
	
	// ò
	USART_InitStructure.USART_BaudRate = baudRate;
	//  ֳ
	USART_InitStructure.USART_WordLength = USART_WordLength_8b;
	// ֹͣλ
	USART_InitStructure.USART_StopBits = USART_StopBits_1;
	// Уλ
	USART_InitStructure.USART_Parity = USART_Parity_No;
	// Ӳ
	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
	// ùģʽշһ
	USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
	// ɴڵĳʼ
	USART_Init(USART1, &USART_InitStructure);
	// ʹܴ
	USART_Cmd(USART1, ENABLE);	 
	//ʹܽж
	USART_ITConfig(USART1, USART_IT_RXNE, ENABLE);	
	
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_4);	//жϿ
	NVIC_InitStructure.NVIC_IRQChannel = USART1_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 4;
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
	NVIC_Init(&NVIC_InitStructure);
#endif	
}
/**
  * @brief  USART2ʼ
  * @param  baudRate: 
  * @retval None
  */
static void USART2_Init(uint32_t baudRate)
{
#ifdef use_USART2
	GPIO_InitTypeDef GPIO_InitStructure;
	USART_InitTypeDef USART_InitStructure;
	NVIC_InitTypeDef NVIC_InitStructure;

	// 򿪴GPIOʱ
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);
	// 򿪴ʱ
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART2, ENABLE);

	// USART TxGPIOΪ츴ģʽ
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOA, &GPIO_InitStructure);
  // USART RxGPIOΪģʽ
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
	GPIO_Init(GPIOA, &GPIO_InitStructure);
	
	// ò
	USART_InitStructure.USART_BaudRate = baudRate;
	//  ֳ
	USART_InitStructure.USART_WordLength = USART_WordLength_8b;
	// ֹͣλ
	USART_InitStructure.USART_StopBits = USART_StopBits_1;
	// Уλ
	USART_InitStructure.USART_Parity = USART_Parity_No;
	// Ӳ
	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
	// ùģʽշһ
	USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
	// ɴڵĳʼ
	USART_Init(USART2, &USART_InitStructure);
	// ʹܴ
	USART_Cmd(USART2, ENABLE);	 
	//ʹܽж
	USART_ITConfig(USART2, USART_IT_RXNE, ENABLE);	
	
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_4);	//жϿ
	NVIC_InitStructure.NVIC_IRQChannel = USART2_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
	NVIC_Init(&NVIC_InitStructure);
#endif	
}
/**
  * @brief  USART3ʼ
  * @param  baudRate: 
  * @retval None
  */
static void USART3_Init(uint32_t baudRate)
{
#ifdef use_USART3
	GPIO_InitTypeDef GPIO_InitStructure;
	USART_InitTypeDef USART_InitStructure;
	NVIC_InitTypeDef NVIC_InitStructure;

	// 򿪴GPIOʱ
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);
	// 򿪴ʱ
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART3, ENABLE);

	// USART TxGPIOΪ츴ģʽ
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOB, &GPIO_InitStructure);
  // USART RxGPIOΪģʽ
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_11;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
	GPIO_Init(GPIOB, &GPIO_InitStructure);
	
	// ò
	USART_InitStructure.USART_BaudRate = baudRate;
	//  ֳ
	USART_InitStructure.USART_WordLength = USART_WordLength_8b;
	// ֹͣλ
	USART_InitStructure.USART_StopBits = USART_StopBits_1;
	// Уλ
	USART_InitStructure.USART_Parity = USART_Parity_No;
	// Ӳ
	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
	// ùģʽշһ
	USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
	// ɴڵĳʼ
	USART_Init(USART3, &USART_InitStructure);
	// ʹܴ
	USART_Cmd(USART3, ENABLE);	 
	//ʹܽж
	USART_ITConfig(USART3, USART_IT_RXNE, ENABLE);	
	
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_4);	//жϿ
	NVIC_InitStructure.NVIC_IRQChannel = USART3_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 3;
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
	NVIC_Init(&NVIC_InitStructure);
#endif	
}
/**
	* @brief  USARTͶַ
	* @param  USARTx: ڼ
	* @param  str: ͵
	* @param 	len: 
  * @retval None
  */
static void USART_SendString1(USART_TypeDef *USARTx, uint8_t *str, uint16_t len)
{

	unsigned short count = 0;
	
	for(; count < len; count++)
	{
		USART_SendData(USARTx, *str++);									//
		while(USART_GetFlagStatus(USARTx, USART_FLAG_TC) == RESET);		//ȴ
	}

}
/**
	* @brief  USARTͲַ
	* @param  USARTx: ڼ
	* @param  str: ͵
  * @retval None
  */
static void USART_SendString2(USART_TypeDef* USARTx, uint8_t *str)
{
	unsigned int k=0;
  do 
  {
      USART_SendData(USARTx, *(str + k) );
			/* ȴݼĴΪ */
			while (USART_GetFlagStatus(USARTx, USART_FLAG_TXE) == RESET){}
      k++;
  }while(*(str + k)!= '\0');
  /* ȴ */
  while(USART_GetFlagStatus(USARTx, USART_FLAG_TC) == RESET){}
}
#ifdef DEBUG_printf
///ضc⺯printfڣضʹprintf
int fputc(int ch, FILE *f)
{
		/* һֽݵ */
		USART_SendData(DEBUG_USART, (uint8_t) ch);
		/* ȴ */
		while (USART_GetFlagStatus(DEBUG_USART, USART_FLAG_TXE) == RESET);		
		return (ch);
}
#else
int fputc(int ch, FILE *f)
{
	return (ch);
}
#endif

